# RSys

Tiny C89 library defining several basic components helpful in the development
of C libraries/applications. Among others, it provides macros that describe the
host environment (OS, compiler, etc.) several low level functionalities
(thread, timer, ref counter, etc.), generic containers (dynamic array, hash
table, etc.) and basic mathematics (linear algebra, quaternions, etc.)

## How to build

The RSys library uses [CMake](http://www.cmake.org) and the
[RCMake](https://gitlab.com/vaplv/rcmake/#tag-readme) package to build. First,
install the RCMake package in a given `<RCMAKE_DIR>` directory. Then, generate
the CMake project from the `cmake/CMakeLists.txt` file by appending the
`<RCMAKE_DIR>` directory to the `CMAKE_PREFIX_PATH` variable. The resulting
project can be now edited, built, tested and installed as any CMake project.

## Release notes

### Version 0.4

- Add the `double2`, `double3`, `double4`, `double33`, `double22` and
`double44` data types that provide the same functionalities of their `float`
alternative.
- Add the `purge` function to the hash table and the dynamic array data
structures. This function not only resets the state of the structure, as the
`clear` function, but also frees its internal memory.
- Implement a new image API that provides and explicit image data structure.
The old API is still available but is deprecated.

## License

RSys is Copyright (C) 2013-2017 Vincent Forest (vaplv@free.fr). It is a free
software released under the [OSI](https://opensource.org)-approved LGPL v3+
license. You are welcome to redistribute it under certain conditions; refer to
the COPYING files for details.

